#include <bits/stdc++.h>
#define endl '\n'
#define pii pair<int,int>
#define fi first
#define se second
#define int long long

using namespace std;

signed main()
{
    ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
    int n,k;
    cin>>n>>k;
    int a[k];
    for(int i=0;i<k;i++)cin>>a[i];
    for(int i=0;i<k;i++){
        if(a[i]==1)cout<<1<<' ';
        else{
            int res=a[i]^1;
            for(int j=2;j<=a[i]/2;j++){
                if(a[i]%j==0)res^=j;
            }
            cout<<res<<' ';
        }
    }
    cout<<'\n';
    return 0;
}